rem $DYNAMIC
' GUI routines by: Jace Masula (momoguru) 2003
' free to use / modify / manipulate
' http://qbasiclab.com
'************* TEMPLATE SUBS ********************************************************

    DECLARE SUB MouseDriver (AX%, BX%, CX%, DX%, lb%, rb%, EX%)
    DECLARE SUB image (imagename$,X%,Y%,size%)
    DECLARE SUB font (text$,X%,Y%,col%,stall%,size%)
    DECLARE SUB inputfont (X%, Y%, length%, col%)
    DECLARE SUB button (X%, Y%, L%, H%, label$, Bcol%, Tcol%, stall%, mode%)
    DECLARE SUB fileload (filename$,linelable$)
    DECLARE SUB timestop (stall%)
    DECLARE SUB windowmake (X%, Y%, W%, H%, wintitle$, mode%)


'************** INITIALIZE TEMPLATE GLOABLS *****************************************
    SCREEN 13
    DIM SHARED xbutton%(100), ybutton%(100), wbutton%(100), hbutton%(100), clickto$(100),action$
    DIM SHARED mouse$, buttonstack%, inputtext$,HLcol1%,HLcol2%,clocktime$
    DIM SHARED winA%(110),winB%(15),winC%(110),winD%(10),winE%(10),winF%(100),winG%(10),winH%(100)
    OPEN "system1.fnt" FOR BINARY AS #1:REDIM SHARED FBuff(0) AS STRING * 8960:GET #1, , FBuff(0):CLOSE #1 
    MouseDriver 1, BX%, CX%, DX%, lb%, rb%, 1
    DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B,5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
    DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F,8B,5E,06,89,17,5D,CA,08,00
    image "window.img",0,0,2600:GET (0,0)-(8,15), winA%:GET (9,0)-(9,15), winB%:GET (30,0)-(38,15), winC%:GET (0,16)-(8,16), winD%:GET (30,16)-(40,16), winE%:GET (0,25)-(8,40), winF%: GET (9,25)-(9,40), winG%:GET (30,25)-(40,40), winH%:CLS
    MouseDriver 2, BX%, CX%, DX%, lb%, rb%, 0

'************************************************************************************
'************************************************************************************














CLS

windowmake 1,1,303,138,"GUI Version 1.0",1
button 10, 15, 100, 8,"quit", 1, 15,0, 1
button 10, 25, 100, 8,"hello world", 1, 15,0, 1  

mainloop:                                                           ' where the actually program loop begins
MouseDriver 1, BX%, CX%, DX%, lb%, rb%, 0                           'initiate the mousey

DO
    MouseDriver 3, BX%, CX%, DX%, lb%, rb%, 0                       'grab mouse data (x,y, and button status)
    xmouse% = INT(CX% / 2) - 1 :  ymouse% = DX% - 1                 ' set Xmouse and Ymouse                               
            
    IF holdbutton% = 1 AND lb% = 0 THEN                             ' these next few lines prevent u from holding the mouse button down
        holdbutton% = 0
        END IF
            
    IF holdbutton% = 0 AND lb% = -1 THEN                            ' if it is a NEW button press
        holdbutton% = 1
        FOR i = 1 TO buttonstack%                                   ' parse thru the buttonstack array to see if a button has been pressed
           IF xmouse% > xbutton%(i) AND xmouse% < (xbutton%(i) + wbutton%(i)) AND ymouse% > ybutton%(i) AND ymouse% < (ybutton%(i) + hbutton%(i)) THEN
            MouseDriver 2, bx%, CX%, DX%, lb%, rb%, 0               'hide the mouse
            action$ = clickto$(i):GOTO actionbutton : EXIT FOR      'go do something if a button has been pressed
           END IF
           NEXT i          
    END IF
LOOP
    

'what to do when a button is pressed
actionbutton:                                                       'what to do when a button is pressed
    IF action$ = "quit" THEN END
    IF action$ = "hello world" THEN PRINT "hi there"
GOTO mainloop                                                       'go back to the beginning and wait for button press


















'******************************* TEMPLATE SUB ROUTINES *******************************************
'******************************* FONT ************************************************************
SUB font (text$, X%, Y%, col%,stall%,size%)
DEF SEG = VARSEG(FBuff(0))
FOR c = 1 TO LEN(text$)
   Ptr = 35 * (ASC(MID$(text$, c, 1)))
   FOR yy = 0 TO 6
      FOR xx = 0 TO 4
         Clr = PEEK(VARPTR(FBuff(0)) + Ptr)
         Ptr = Ptr + 1
         IF Clr THEN 
            IF size% = 0 THEN PSET (xx + X%, yy + Y%), col%
            IF size% = 1 THEN LINE ((xx*2) + X%, (yy*2) + Y%)-((xx*2) + X%+1, (yy*2) + Y%+1),col%,BF 
         END IF
      NEXT xx
   NEXT yy
      timestop stall%
      X% = X% + 5+(size%*10)/2
      
NEXT c
END SUB

'******************************* INPUT FONT *******************************************************
SUB inputfont (X%, Y%, length%, col%)
    inputlength% = length%
    length% = length% * 6
    inputtext$ = ""
    inputdata$ = ""
    text$ = " "
    DEF SEG = VARSEG(FBuff(0))

inputrefresh:
    FOR c = 1 TO LEN(text$)
       Ptr = 35 * (ASC(MID$(text$, c, 1)))
       FOR yy = 0 TO 6
          FOR xx = 0 TO 4
             Clr = PEEK(VARPTR(FBuff(0)) + Ptr)
             Ptr = Ptr + 1
             IF Clr THEN PSET (xx + X%, yy + Y%), col%
          NEXT xx
       NEXT yy
       X% = X% + 5
    NEXT c

selector:
    DO
        LINE (xx + X% - 5, yy + Y% - 0)-(xx + X%, yy + Y% - 7), col%, BF
        inputdata$ = INKEY$
        IF inputdata$ = CHR$(27) OR inputdata$ = CHR$(8) THEN GOTO backspace
        IF inputdata$ <> "" AND inputdata$ <> CHR$(9) AND inputdata$ <> CHR$(13) AND LEN(inputtext$) < inputlength% - 1 THEN GOTO construct
        IF inputdata$ = CHR$(13) OR inputdata$ = CHR$(9) THEN GOTO ender
    LOOP

backspace:
    IF LEN(inputtext$) <> 0 THEN
    textlength% = LEN(inputtext$) - 1
    inputtext$ = LEFT$(inputtext$, textlength%)
    LINE (xx + X% - 6, yy + Y% - 0)-(xx + X%, yy + Y% - 7), 0, BF
    X% = X% - 5
    END IF
    GOTO selector

construct:
    LINE (xx + X% - 6, yy + Y% - 0)-(xx + X%, yy + Y% - 7), 0, BF
    inputtext$ = inputtext$ + inputdata$
    text$ = inputdata$
    GOTO inputrefresh

ender:
    LINE (xx + X% - 6, yy + Y% - 0)-(xx + X%, yy + Y% - 7), 0, BF
    END SUB

'******************************** IMAGE LOADER ****************************************************
SUB image (imagename$,X%,Y%,size%)
REDIM spritegrafix(size%)
            DEF SEG = VARSEG(spritegrafix(0)): BLOAD imagename$, 0
            PUT (X%, Y%), spritegrafix, PSET
            DEF SEG
END SUB   
         
'******************************** MOUSE DRIVER  ***************************************************
DEFSNG A-Z
SUB MouseDriver (AX%, BX%, CX%, DX%, lb%, rb%, EX%)
    IF EX% = 1 THEN
        mouse$ = SPACE$(57)
        FOR i% = 1 TO 57
        READ A$
        H$ = CHR$(VAL("&H" + A$))
        MID$(mouse$, i%, 1) = H$
        NEXT i%
    END IF
    DEF SEG = VARSEG(mouse$)
    CALL ABSOLUTE(AX%, BX%, CX%, DX%, SADD(mouse$))
    lb% = ((BX% AND 1) <> 0)
    rb% = ((BX% AND 2) <> 0)
END SUB

'********************************* BUTTONS ********************************************************
SUB button (X%, Y%, L%, H%, label$, Bcol%, Tcol%,stall%, mode%)
    IF mode% = 1 THEN
        buttonstack% = buttonstack% + 1
        xbutton%(buttonstack%) = X%
        ybutton%(buttonstack%) = Y%
        wbutton%(buttonstack%) = L%
        hbutton%(buttonstack%) = H%
        clickto$(buttonstack%) = label$
    END IF
    

    IF Bcol% = -1 THEN                                                ' -1: Transparent Button Box
        LINE (X%, Y%)-(X% + L%, Y% + H%), Bcol%, B
        font label$, X%+3, Y%, Tcol%,stall%,0
    ELSEIF Bcol% = -2 THEN                                            ' -2: No Box, just text
        font label$, X%+15, Y%,Tcol%,stall%,0
    ELSEIF Bcol% = -3 THEN                                            ' -3: Hotspot invisible button
        'hidden button                                                                
    ELSE                                                              ' Default Button Box
        LINE (X%, Y%)-(X% + L%, Y% + H%), Bcol%, BF
        LINE (X%, Y%)-(X% + L%, Y% + H%), BScol%, B
        LINE (X%, Y%)-(X% + L%, Y%), BHcol%
        LINE (X%, Y%)-(X%, Y% + H%), BHcol%
        font label$, X%+3, Y%, Tcol%,stall%,0
    END IF
        
END SUB
'********************************* TIMESTOP *********************************************************
SUB timestop (stall%)
    FOR lag = 1 TO stall%
    NEXT lag

END SUB

'********************************* WINDOW MAKING ROUTINE ********************************************
SUB windowmake (X%, Y%, W%, H%, wintitle$, mode%)
    IF mode% = 1 THEN
        PUT (X%,Y%), winA%,PSET: PUT (X%+W%+1,Y%), winC%,PSET: PUT (X%,Y%+H%+1), winF%,PSET:PUT (X%+W%+1,Y%+H%+1), winH%,PSET                       
        FOR winL% = 1 TO W%-8:PUT (X%+winL%+8,Y%), winB%,PSET:PUT (X%+winL%+8,Y%+H%+1), winG%,PSET:NEXT winL%
        FOR winH% = 1 TO H%-15:PUT (X%,Y%+winH%+15), winD%,PSET:PUT (X%+W%+1,Y%+winH%+15), winE%,PSET:NEXT winH% 
        font wintitle$, X%+2, Y%+2, 120,1,0
        LINE(X%+6,Y%+13)-(X%+W%+3,Y%+H%+8),0,BF
    END IF
    font wintitle$, X%+3, Y%+1, 15,1,0    
END SUB



































